%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   The following function should print out the convergence
%   rate of explicit method (theta = 0), implicit method
%   (theta = 1) and midpoint method (theta = 1/2)
%
%   Function declaration:
%   function ConvergenceRate
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function ConvergenceRate

% Initial value
x0 = ;

% Right-hand side of ODE system
odefun = ;

% End time
T0 = ;

N = 10;

% Step size array
dt = 1./2.^(1:N);

% Tolerance
tol = 10^(-6);

% Exact solution
exact = @(t) 2*exp(t^2/2) - t^2 - 2;

err_exp = zeros(1,N);
err_imp = zeros(1,N);
err_mid = zeros(1,N);

for i=1:N
    % Error to ExplicitMethod for step size 1/(2^i)
    err_exp(i) = ;

    % Errors to ImplicitMethod for step size 1/(2^i)
    err_imp(i) = ;

    % Errors to MidpointMethod for step size 1/(2^i)
    err_mid(i) = ;
end

fit_exp = polyfit(log(dt), log(err_exp), 1);
fprintf('Convergence order of Explicit method: %f\n', fit_exp(1));

fit_imp = polyfit(log(dt), log(err_imp), 1);
fprintf('Convergence order of Implicit method: %f\n', fit_imp(1));

fit_mid = polyfit(log(dt), log(err_mid), 1);
fprintf('Convergence order of Midpoint method: %f\n', fit_mid(1));
end